#include "grille.h"

Grille::Grille()
{
	set_graph(0,0);
	for(int i = 0; i < 9; i ++)
	{
		sprintf(chaine, "media/%d.bmp", i+1);
		aff_nb[i] = SDL_LoadBMP(chaine);
		SDL_SetColorKey(aff_nb[i], SDL_SRCCOLORKEY, SDL_MapRGB(aff_nb[i]->format, 0, 255, 0));
	}
	id_save = 0;
	caption_aff();
	init();
}

void Grille::set_graph(int graph_mode, int need_rst)
{
	if(need_rst)
	{
		for(int i = 0; i < 6; i ++)
		{
			SDL_FreeSurface(car[i]);
		}
	}
	if(graph_mode == 0)
	{
		for(int i = 0; i < 5; i ++)
		{
			car[i] = SDL_CreateRGBSurface(SDL_HWSURFACE, 64, 64, 32, 0, 0, 0, 0);
		}
		SDL_FillRect(car[0], NULL, SDL_MapRGB(car[0]->format, 255, 255, 255));
		SDL_FillRect(car[1], NULL, SDL_MapRGB(car[1]->format, 255, 127, 0));
		SDL_FillRect(car[2], NULL, SDL_MapRGB(car[2]->format, 255, 255, 50));
		SDL_FillRect(car[3], NULL, SDL_MapRGB(car[3]->format, 50, 255, 255));
		SDL_FillRect(car[4], NULL, SDL_MapRGB(car[4]->format, 255, 0, 0));
	}
	else
	{
		for(int i = 0; i < 5; i ++)
		{
			sprintf(chaine, "media/car_%d.bmp", i);
			car[i] = SDL_LoadBMP(chaine);
		}
	}
	car[5] = SDL_CreateRGBSurface(SDL_HWSURFACE, 64, 64, 32, 0, 0, 0, 0);
	SDL_FillRect(car[5], NULL, SDL_MapRGB(car[5]->format, 0, 0, 0));
	SDL_SetAlpha(car[5], SDL_SRCALPHA, 50);
}

void Grille::caption_aff()
{
	sprintf(chaine, "saves/save_%d.sudoku", id_save);
	SDL_WM_SetCaption(chaine, NULL);
}

void Grille::save_id()
{
	sprintf(chaine, "saves/save_%d.sudoku", id_save);
	save(chaine);
}

void Grille::load_id()
{
	sprintf(chaine, "saves/save_%d.sudoku", id_save);
	load(chaine);
}

void Grille::id_save_mod(int mod_val)
{
	if(id_save + mod_val < 0)
	{
		id_save = 0;
	}
	else
	{
		id_save += mod_val;
	}
	caption_aff();
}

void Grille::save(const char*f_name)
{
	fich = fopen(f_name, "w+");
	for(int i = 0; i < 9; i ++)
	{
		for(int j = 0; j < 9; j ++)
		{
			fprintf(fich, "%d ", grille[j][i]);
		}
		fprintf(fich, "\n");
	}
	fprintf(fich, "\n");
	for(int i = 0; i < 9; i ++)
	{
		for(int j = 0; j < 9; j ++)
		{
			fprintf(fich, "%d ", b_grille[j][i]);
		}
		fprintf(fich, "\n");
	}
	fclose(fich);
}

void Grille::load(const char*f_name)
{
	fich = fopen(f_name, "r");
	for(int i = 0; i < 9; i ++)
	{
		for(int j = 0; j < 9; j ++)
		{
			fscanf(fich, "%d", &grille[j][i]);
		}
	}
	for(int i = 0; i < 9; i ++)
	{
		for(int j = 0; j < 9; j ++)
		{
			fscanf(fich, "%d", &b_grille[j][i]);
		}
	}
	fclose(fich);
}

void Grille::clear()
{
	for(int i = 0; i < 9; i ++)
	{
		for(int j = 0; j < 9; j ++)
		{
			if(!b_grille[i][j])
			{
				grille[i][j] = 0;
			}
		}
	}
}

int Grille::max_solve(SDL_Surface *ecran)
{
	save("supo/first.sudoku");
	result = 1;
	ms_x = 0;
	ms_y = 0;
	ms_val = 1;
	while(!fini())
	{
		load("supo/first.sudoku");
		while(result && !fini())
		{
			while(result && !fini())
			{
				result = calcul_not(ecran);
			}
			if(!result)
			{
				while(grille[ms_x][ms_y] != 0 && ms_y < 9)
				{
					ms_x++;
					if(ms_x >= 9)
					{
						ms_x = 0;
						ms_y ++;
					}
				}
				if(ms_y >= 9)
				{
					result = 0;
				}
				else
				{
					
				}
			}
		}
	}
	return result;
}

int Grille::solve(SDL_Surface *ecran)
{
	result = 1;
	while(result && !fini())
	{
		result = calcul_not(ecran);
	}
	/*if(!fini())
	{
		return max_solve(ecran);
	}*/
	return result;
}

int Grille::calcul_not(SDL_Surface *ecran)
{
	int rtval = 0;
	for(int i = 0; i < 9; i ++)
	{
		for(int j = 0; j < 9; j ++)
		{
			for(int k = 0; k < 9; k ++)
			{
				not_grille[i][j][k] = 1;
			}
		}
	}
	for(int i = 0; i < 9; i ++)
	{
		not_ligne(i);
		not_col(i);
	}
	for(int i = 0; i < 3; i ++)
	{
		for(int j = 0; j < 3; j ++)
		{
			not_case(i,j);
		}
	}
	for(int i = 0; i < 9; i ++)
	{
		for(int j = 0; j < 9; j ++)
		{
			for(int k = 0; k < 9; k ++)
			{
				if(b_grille[i][j])
				{
					not_grille[i][j][k] = 0;
				}
			}
		}
	}
	for(int i = 0; i < 9; i ++)
	{
		for(int j = 0; j < 9; j ++)
		{
			nb_pos = 0;
			val = 0;
			for(int k = 0; k < 9; k ++)
			{
				if(not_grille[i][j][k])
				{
					nb_pos++;
					val = k;
				}
			}
			if(nb_pos == 1 && grille[i][j] == 0)
			{
				//grille[i][j] = val+1;
				def_sel(i*66,j*66);
				key(SDLK_KP1+val);
				rtval = 1;
				afficher(ecran);
				SDL_Flip(ecran);
			}
		}
	}
	for(int i = 0; i < 3; i ++)
	{
		for(int j = 0; j < 3; j ++)
		{
			rtval = rtval || cal_case(i,j,ecran);
		}
	}
	for(int i = 0; i < 9; i ++)
	{
		rtval = rtval || cal_ligne(i,ecran);
		rtval = rtval || cal_col(i,ecran);
	}
	printf("Turn\n");
	return rtval;
}

void Grille::afficher(SDL_Surface *ecran)
{
	if(!fini())
	{
		SDL_FillRect(ecran, NULL, SDL_MapRGB(ecran->format, 64, 64, 64));
	}
	else
	{
		SDL_FillRect(ecran, NULL, SDL_MapRGB(ecran->format, 0, 128, 0));
	}
	for(int i = 0; i < 9; i ++)
	{
		for(int j = 0; j < 9; j ++)
		{
			pos.x = (2+(i*66)+(2*(i/3)));
			pos.y = (2+(j*66)+(2*(j/3)));
			if(selector.x >= 10 || selector.y >= 10)
			{
				SDL_BlitSurface(car[0], NULL, ecran, &pos);
			}
			else if(selector.x == i && selector.y == j)
			{
				if(error)
				{
					SDL_BlitSurface(car[4], NULL, ecran, &pos);
				}
				else
				{
					SDL_BlitSurface(car[1], NULL, ecran, &pos);
				}
			}
			else if(grille[selector.x][selector.y] > 0 && grille[i][j] == grille[selector.x][selector.y])
			{
				SDL_BlitSurface(car[3], NULL, ecran, &pos);
			}
			else if(selector.x == i || selector.y == j||(selector.x/3 == i/3 && selector.y/3 == j/3))
			{
				SDL_BlitSurface(car[2], NULL, ecran, &pos);
			}
			else
			{
				SDL_BlitSurface(car[0], NULL, ecran, &pos);
			}
			if(b_grille[i][j])
			{
				SDL_BlitSurface(car[5], NULL, ecran, &pos);
			}
			if(grille[i][j]>0)
			{
				SDL_BlitSurface(aff_nb[grille[i][j]-1], NULL, ecran, &pos);
			}
		}
	}
}

void Grille::def_sel(int x, int y)
{
	error = 0;
	selector.x = ((x/66));
	selector.y = ((y/66));
	//printf("%d %d %d %d\n", x, y, selector.x, selector.y);
	if(selector.x <0 || selector.x >= 9)
	{
		selector.x = 10;
	}
	if(selector.y <0 || selector.y >= 9)
	{
		selector.y = 10;
	}
}

void Grille::key(int key_push)
{
	error = 0;
	if(key_push >= SDLK_KP0 && key_push <= SDLK_KP9)
	{
		val = key_push - SDLK_KP0;
		printf("input %d\n", val);
		if(selector.x < 10 && selector.y < 10)
		{
			last_val = grille[selector.x][selector.y];
			grille[selector.x][selector.y] = val;
			if(!check() || b_grille[selector.x][selector.y])
			{
				grille[selector.x][selector.y] = last_val;
				error = 1;
			}
		}
	}
}

int Grille::fini()
{
	for(int i = 0; i < 9; i ++)
	{
		for(int j = 0; j < 9; j ++)
		{
			if(grille[i][j] == 0)
			{
				return 0;
			}
		}
	}
	return 1;
}

int Grille::check()
{
	for(int i = 0; i < 9; i ++)
	{
		if(!check_ligne(i) || !check_col(i))
		{
			return 0;
		}
	}
	for(int i = 0; i < 3; i ++)
	{
		for(int j = 0; j < 3; j ++)
		{
			if(!check_case(i,j))
			{
				return 0;
			}
		}
	}
	return 1;
}

int Grille::check_case(int x, int y)
{
	init_vals();
	for(int i = 0; i < 9; i ++)
	{
		vals[i] = grille[(x*3)+(i/3)][(y*3)+(i%3)];
	}
	for(int i = 0; i < 9; i ++)
	{
		for(int j = 0; j < 9; j ++)
		{
			if(vals[i] == 0)
			{
				break;
			}
			if(i != j && vals[i] == vals[j])
			{
				return 0;
			}
		}
	}
	return 1;
}

int Grille::check_ligne(int y)
{
	init_vals();
	for(int i = 0; i < 9; i ++)
	{
		vals[i] = grille[i][y];
	}
	for(int i = 0; i < 9; i ++)
	{
		for(int j = 0; j < 9; j ++)
		{
			if(vals[i] == 0)
			{
				break;
			}
			if(i != j && vals[i] == vals[j])
			{
				return 0;
			}
		}
	}
	return 1;
}

int Grille::check_col(int x)
{
	init_vals();
	for(int i = 0; i < 9; i ++)
	{
		vals[i] = grille[x][i];
	}
	for(int i = 0; i < 9; i ++)
	{
		for(int j = 0; j < 9; j ++)
		{
			if(vals[i] == 0)
			{
				break;
			}
			if(i != j && vals[i] == vals[j])
			{
				return 0;
			}
		}
	}
	return 1;
}

int Grille::cal_case(int x, int y, SDL_Surface *ecran)
{
	int rtval = 0;
	for(int k = 0; k < 9; k ++)
	{
		init_vals();
		for(int i = 0; i < 9; i ++)
		{
			vals[i] = not_grille[(x*3)+(i/3)][(y*3)+(i%3)][k];
		}
		nb_pos = 0;
		val = 0;
		for(int l = 0; l < 9; l ++)
		{
			if(vals[l])
			{
				nb_pos++;
				val = k;
			}
		}
		for(int i = 0; i < 9; i ++)
		{
			if(nb_pos == 1 && grille[(x*3)+(i/3)][(y*3)+(i%3)] == 0 && not_grille[(x*3)+(i/3)][(y*3)+(i%3)][k] == 1)
			{
				//grille[i][j] = val+1;
				def_sel(((x*3)+(i/3))*66,((y*3)+(i%3))*66);
				key(SDLK_KP1+val);
				rtval = 1;
				afficher(ecran);
				SDL_Flip(ecran);
			}
		}
	}
	return rtval;
}

int Grille::cal_ligne(int y, SDL_Surface *ecran)
{
	int rtval = 0;
	for(int k = 0; k < 9; k ++)
	{
		init_vals();
		for(int i = 0; i < 9; i ++)
		{
			vals[i] = not_grille[i][y][k];
		}
		nb_pos = 0;
		val = 0;
		for(int l = 0; l < 9; l ++)
		{
			if(vals[l])
			{
				nb_pos++;
				val = k;
			}
		}
		for(int i = 0; i < 9; i ++)
		{
			if(nb_pos == 1 && grille[i][y] == 0 && not_grille[i][y][k] == 1)
			{
				//grille[i][j] = val+1;
				def_sel(i*66,y*66);
				key(SDLK_KP1+val);
				rtval = 1;
				afficher(ecran);
				SDL_Flip(ecran);
			}
		}
	}
	return rtval;
}

int Grille::cal_col(int x, SDL_Surface *ecran)
{
	int rtval = 0;
	for(int k = 0; k < 9; k ++)
	{
		init_vals();
		for(int i = 0; i < 9; i ++)
		{
			vals[i] = not_grille[x][i][k];
		}
		nb_pos = 0;
		val = 0;
		for(int l = 0; l < 9; l ++)
		{
			if(vals[l])
			{
				nb_pos++;
				val = k;
			}
		}
		for(int i = 0; i < 9; i ++)
		{
			if(nb_pos == 1 && grille[x][i] == 0 && not_grille[x][i][k] == 1)
			{
				//grille[i][j] = val+1;
				def_sel(x*66,i*66);
				key(SDLK_KP1+val);
				rtval = 1;
				afficher(ecran);
				SDL_Flip(ecran);
			}
		}
	}
	return rtval;
}

int Grille::not_case(int x, int y)
{
	init_vals();
	for(int i = 0; i < 9; i ++)
	{
		vals[i] = grille[(x*3)+(i/3)][(y*3)+(i%3)];
	}
	for(int i = 0; i < 9; i ++)
	{
		for(int j = 0; j < 9; j ++)
		{
			if(vals[i] == 0)
			{
				break;
			}
			not_grille[(x*3)+(j/3)][(y*3)+(j%3)][vals[i]-1] = 0;
		}
	}
	return 1;
}

int Grille::not_ligne(int y)
{
	init_vals();
	for(int i = 0; i < 9; i ++)
	{
		vals[i] = grille[i][y];
	}
	for(int i = 0; i < 9; i ++)
	{
		for(int j = 0; j < 9; j ++)
		{
			if(vals[i] == 0)
			{
				break;
			}
			not_grille[j][y][vals[i]-1] = 0;
		}
	}
	return 1;
}

int Grille::not_col(int x)
{
	init_vals();
	for(int i = 0; i < 9; i ++)
	{
		vals[i] = grille[x][i];
	}
	for(int i = 0; i < 9; i ++)
	{
		for(int j = 0; j < 9; j ++)
		{
			if(vals[i] == 0)
			{
				break;
			}
			not_grille[x][j][vals[i]-1] = 0;
		}
	}
	return 1;
}

void Grille::init_vals()
{
	for(int i = 0; i < 9; i ++)
	{
		vals[i] = 0;
	}
}

void Grille::set_block()
{
	for(int i = 0; i < 9; i ++)
	{
		for(int j = 0; j < 9; j ++)
		{
			if(grille[i][j] != 0)
			{
				b_grille[i][j] = 1;
			}
		}
	}
}

void Grille::init()
{
	for(int i = 0; i < 9; i ++)
	{
		for(int j = 0; j < 9; j ++)
		{
			grille[i][j] = 0;
			b_grille[i][j] = 0;
		}
	}
	selector.x = 10;
	selector.y = 10;
	error = 0;
	supo_id = 0;
	supo_posi = 2;
}
